/*******************************************************************************
 * Copyright (c) 2025, Jan Koester jan.koester@gmx.net
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * Neither the name of the <organization> nor the
 *      names of its contributors may be used to endorse or promote products
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *******************************************************************************/

#include <vector>
#include <uuidp.h>

#include "authdb.h"
#include "backend.h"


#pragma once

namespace authdb {
    class GpoData : public AuthData{
    public:
        GpoData(uuid::uuid gpid);
        GpoData(const GpoData& src);
        ~GpoData();

        void setName(const char *src);
        const char *getName();

        void setDesc(const char *src);
        const char *getDesc();

        void setGpoValue(const bool dest);
        bool getGpoValue();

    public:
        void setAllowed(const std::vector<uuid::uuid> &allowed);
        void getAlowed(std::vector<uuid::uuid> &allowed);
    private:
        AuthData::Record* _Name;
        AuthData::Record* _Desc;
        AuthData::Record* _GpoDefault;
        AuthData::Record* _Allowed;
        friend class Gpo;
    };

    class Gpo {
    public:
        bool exists(AuthBackend &backend,const uuid::uuid &gpid,const char *name, int &ret);
        void create(AuthBackend& backend, class GpoData* dat);
        void edit(AuthBackend &backend, class GpoData &dat);
        void remove(AuthBackend &backend,const uuid::uuid &gpid);
        void info(AuthBackend &backend, class GpoData& dat, size_t &pos);
        void list(AuthBackend &backend,std::vector<uuid::uuid> &uuids);
    };
};
